Bug 887962 (CVE-2012-5643)

Summary: CVE-2012-5643 squid: cachemgr.cgi memory usage DoS and memory leaks
Product: [Other] Security Response Reporter: Jan Lieskovsky <jlieskov>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: henrik, herrold, jonathansteffan, mluscon, thozza, tis
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=moderate,public=20121217,reported=20121217,source=upstream,cvss2=5.0/AV:N/AC:L/Au:N/C:N/I:N/A:P,rhel-5/squid=wontfix,rhel-6/squid=affected,fedora-16/squid=affected,cwe=CWE-401[auto]
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-08-28 10:27:45 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 887964, 888198    
Bug Blocks: 855229, 887969    

Description Jan Lieskovsky 2012-12-17 12:19:44 EST
A denial of service flaw was found in the way the CGI Cache Manager of the Squid proxy caching server processed certain requests. A remote attacker could this this flaw to cause the squid service to consume excessive amount of resources.

References:
[1] http://www.squid-cache.org/Advisories/SQUID-2012_1.txt
[2] https://bugs.gentoo.org/show_bug.cgi?id=447596
[3] https://secunia.com/advisories/51545/

Upstream patches:
[4] http://www.squid-cache.org/Versions/v3/3.1/changesets/squid-3.1-10479.patch
    (against the 3.1 branch)
[5] http://www.squid-cache.org/Versions/v3/3.2/changesets/squid-3.2-11714.patch
    (against the 3.2 branch)
Comment 1 Jan Lieskovsky 2012-12-17 12:21:41 EST
This issue affects the versions of the squid package, as shipped with Red Hat Enterprise Linux 5 and 6.

--

This issue affects the version of the squid package, as shipped with Fedora release of 16. Please schedule an update.
Comment 2 Jan Lieskovsky 2012-12-17 12:22:39 EST
Created squid tracking bugs for this issue

Affects: fedora-16 [bug 887964]
Comment 3 Jan Lieskovsky 2012-12-17 12:31:28 EST
CVE Request:
[6] http://www.openwall.com/lists/oss-security/2012/12/17/3
Comment 4 Jan Lieskovsky 2012-12-17 12:54:47 EST
The CVE identifier of CVE-2012-5643 has been assigned to this issue:
  http://www.openwall.com/lists/oss-security/2012/12/17/4
Comment 8 Fedora Update System 2012-12-25 23:56:17 EST
squid-3.2.5-1.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 10 Jan Lieskovsky 2013-01-16 07:12:34 EST
(In reply to comment #9)
> Several problems were identified with the original patch, hence upstream
> SQUID-2012:1 advisory and patches were updated with additional fixes.
> 

The 'incomplete fix for CVE-2012-5643' issue has got an independent identifier of CVE-2013-0189 and is now tracked under dedicated bug 895972.
Comment 11 errata-xmlrpc 2013-02-21 03:40:05 EST
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2013:0505 https://rhn.redhat.com/errata/RHSA-2013-0505.html
Comment 13 Tomas Hoger 2013-07-30 10:29:07 EDT
(In reply to Tomas Hoger from comment #9)
> Several problems were identified with the original patch, hence upstream
> SQUID-2012:1 advisory and patches were updated with additional fixes.
> 
> Updated patches:
> http://www.squid-cache.org/Versions/v3/3.1/changesets/SQUID-2012_1.patch
> http://www.squid-cache.org/Versions/v3/3.2/changesets/SQUID-2012_1.patch
> 
> Individual commits (including commits for the initial fix):
> http://bazaar.launchpad.net/~squid/squid/3.1/revision/10479
> http://bazaar.launchpad.net/~squid/squid/3.1/revision/10483
> http://bazaar.launchpad.net/~squid/squid/3.1/revision/10484

Additional problem was found in the patch for Squid 3.1.  SQUID-2012:1 patch for 3.1 is now updated to include this additional fix:

http://bazaar.launchpad.net/~squid/squid/3.1/revision/10486
http://bugs.squid-cache.org/show_bug.cgi?id=3790

Fixes for squid packages in Red Hat Enterprise Linux 6 released via RHSA-2013:0505 contain this issue - bug 990186 was filed to track the regression.
Comment 14 Tomas Hoger 2013-07-30 11:08:50 EDT
Few notes on the original problem and its mitigation:

- cachemgr.cgi is included in the main squid package in Red Hat Enterprise Linux, hence it is installed whenever squid package is installed.

- cachemgr.cgi is only exposed if httpd is also installed and running.  The squid package does not require httpd, so proxy server can run with only squid service running, but httpd service disabled or not installed.

- default configuration in /etc/httpd/conf.d/squid.conf only allow clients form localhost.localdomain to send request to the cachemgr.cgi CGI application.  This problem is only exposed to remote hosts/attackers if this default configuration is changed.

This problem can be mitigated by not running httpd service, blocking access to the cachemgr.cgi if it's not used, or limiting access to only trusted sources.
Comment 16 Tomas Hoger 2014-08-28 10:27:45 EDT
Statement:

Red Hat Enterprise Linux 5 is now in Production 3 Phase of the support and maintenance life cycle. This has been rated as having Moderate security impact and is not currently planned to be addressed in future updates. For additional information, refer to the Red Hat Enterprise Linux Life Cycle: https://access.redhat.com/support/policy/updates/errata/.